☝️Small business or a startup? See if you qualify for our special offer.
+
List of all demos

Angular Pivot Table: classic (tabular) view

The classic (tabular) form displays the data in an Excel-like layout of hierarchies. Using the classic Angular pivot table, you can see hierarchy sublevels in separate rows or columns next to each other.


    import { Component, OnInit, ViewChild } from "@angular/core";
    import { FlexmonsterPivot } from "ng-flexmonster";
    
    @Component({
      selector: "pivotComponent",
      templateUrl: "./pivot.component.html",
      styleUrls: ["./pivot.component.css"],
    })
    export class PivotComponent implements OnInit {
      @ViewChild("pivot") pivot!: FlexmonsterPivot;
    
      public report: Object = {
        dataSource: {
          type: "csv",
          filename: "data/data.csv",
        },
        options: {
          grid: {
            type: "classic",
          },
        },
        slice: {
          rows: [
            {
              uniqueName: "Country",
            },
            {
              uniqueName: "Business Type",
            },
          ],
          columns: [
            {
              uniqueName: "Color",
            },
            {
              uniqueName: "[Measures]",
            },
          ],
          measures: [
            {
              uniqueName: "Price",
              format: "currency"
            },
          ],
          expandAll: true,
        },
        formats: [
          {
            name: "",
            thousandsSeparator: ",",
            decimalSeparator: ".",
            decimalPlaces: 2,
          },
          {
            name: "currency",
            currencySymbol: "$",
          },
        ],
      };
    
      constructor() {}
    
      ngOnInit(): void {}
    
      changeLayout(layoutType: string) {
        this.pivot.flexmonster.setOptions({
          grid: {
            type: layoutType,
          },
        });
        this.pivot.flexmonster.refresh();
      }
    }
    
    <button (click)="changeLayout('compact')">Use compact form</button>
    <button (click)="changeLayout('classic')">Use classic form</button>
    
    <fm-pivot
      #pivot
      [componentFolder]="'https://cdn.flexmonster.com/'"
      [height]="450"
      [report]="report">
    </fm-pivot>
    

    With a tabular layout, you have the access to the same data visualization functionality as in compact form. All Excel features work the same: via a comfy Angular UI grid, you can sort and filter rows and columns, drill through the data, expand and collapse the hierarchies.

    If data in your Angular pivot grid has a deep hierarchy with a lot of sublevels, we recommend switching to the compact form which shows multi-level hierarchies more neatly and saves space in the table.

☝️Small business or a startup? See if you qualify for our special offer.
+
List of all demos

React Pivot Table: classic (tabular) view

The classic (tabular) form is a React pivot table’s view, which you can switch to, to see an Excel-like layout of hierarchies. With the classic pivot table view, you can show sublevels in separate rows or columns next to one another.


    import React from "react";
    import * as FlexmonsterReact from "react-flexmonster";
    
    class PivotTableDemo extends React.Component {
      constructor(props) {
        super(props);
        this.pivot = React.createRef();
      }
    
      render() {
        return (
          <>
           <button onClick={() => this.changeLayout("compact")}>Use compact form</button>
           <button onClick={() => this.changeLayout("classic")}>Use classic form</button>
    
            <FlexmonsterReact.Pivot
              ref={this.pivot}
              componentFolder="https://cdn.flexmonster.com/"
              height={450}
              report={{
                dataSource: {
                  type: "csv",
                  filename: "data/data.csv",
                },
                options: {
                  grid: {
                    type: "classic",
                  },
                },
                slice: {
                  rows: [
                    {
                      uniqueName: "Country",
                    },
                    {
                      uniqueName: "Business Type",
                    },
                  ],
                  columns: [
                    {
                      uniqueName: "Color",
                    },
                    {
                      uniqueName: "[Measures]",
                    },
                  ],
                  measures: [
                    {
                      uniqueName: "Price",
                      format: "currency"
                    },
                  ],
                  expandAll: true,
                },
                formats: [
                  {
                    name: "",
                    thousandsSeparator: ",",
                    decimalSeparator: ".",
                    decimalPlaces: 2,
                  },
                  {
                    name: "currency",
                    currencySymbol: "$",
                  },
                ],
              }}
            />
          </>
        );
      }
    
      changeLayout = (layoutType) => {
        this.pivot.current.flexmonster.setOptions({
          grid: {
            type: layoutType,
          },
        });
        this.pivot.current.flexmonster.refresh();
      };
    }
    
    export default PivotTableDemo;
    

    By default, grand totals are displayed at the end of each row, and subtotals are placed at the bottom in a separate row.

    All the React pivot table functionality works familiar — in the way you got used to it in Excel. You can drag and drop, expand, collapse, drill down and up the hierarchies, sort and drill through values, and more.

    In case multi-level hierarchies from your report include a lot of sublevels, it is better to switch to the compact form, which shows them more neatly and will save space on the page.

☝️Small business or a startup? See if you qualify for our special offer.
+
List of all demos

Vue Pivot Table: classic (tabular) view

The classic (tabular) form of the pivot table is an Excel-like layout where hierarchies sublevel are placed next to one another in separate rows or columns.


    <template>
      <button v-on:click="changeLayout('compact')">Use compact form</button>
      <button v-on:click="changeLayout('classic')">Use classic form</button>
    
      <Pivot 
        ref="pivot"
        componentFolder="https://cdn.flexmonster.com/"
        height="450" 
        v-bind:report="report"
      />
    </template>
    
    <script>
    import Pivot from "vue-flexmonster/vue3";
    import "flexmonster/flexmonster.css";
    
    export default {
      name: "PivotComponent",
      components: {
        Pivot,
      },
      data() {
        return {
          report: {
            dataSource: {
              type: "csv",
              filename: "data/data.csv",
            },
            options: {
              grid: {
                type: "classic",
              },
            },
            slice: {
              rows: [
                {
                  uniqueName: "Country",
                },
                {
                  uniqueName: "Business Type",
                },
              ],
              columns: [
                {
                  uniqueName: "Color",
                },
                {
                  uniqueName: "[Measures]",
                },
              ],
              measures: [
                {
                  uniqueName: "Price",
                  format: "currency"
                },
              ],
              expandAll: true,
            },
            formats: [
             {
               name: "",
               thousandsSeparator: ",",
               decimalSeparator: ".",
               decimalPlaces: 2,
             },
             {
               name: "currency",
               currencySymbol: "$",
             },
           ],
          },
        };
      },
      methods: {
        changeLayout(layoutType) {
          this.$refs.pivot.flexmonster.setOptions({
            grid: {
              type: layoutType,
            },
          });
          this.$refs.pivot.flexmonster.refresh();
        },
      },
    };
    </script>
    

    Compared to the default compact form of the Vue pivot table, where grand totals are displayed at the end of each row and subtotals are displayed in a separate row at the bottom, the classic form shows data as the tabular layout in Excel.

    The pivot functionality stays the same. It's only up to you how you want your Vue pivot grid to look.

    Still, for multi-level hierarchies with many sublevels, it's better to use a compact form to show data more smartly.